#!/bin/sh
#
# pppserver     PPP Over SSL server daemon
#
# chkconfig: 2345 90 20
# description: pppserver is a networking daemon to build cheap VPN
#              over SSL using ppp.
#              User authentication is done using X509 Certificates
# processname: pppserver
# pidfile: /var/run/pppserver.pid
# config: /usr/local/etc/ssltunnel/tunnel.conf
#
# 02/06/2003 : Creation
#
# Copyright Herv Schauer Consultants (http://www.hsc.fr/)
#           Alain Thivillon (at@rominet.net)
#

prefix=/usr/local
exec_prefix=${prefix}

# See how we are called
case "$1" in
  start)
      ${exec_prefix}/libexec/pppserver ${prefix}/etc/ssltunnel/tunnel.conf
      ;;
  stop)
      kill `cat /var/run/pppserver.pid`
      ;;
  restart)
      $0 stop
      $0 start
      ;;
  *)
      echo "$0 {stop|start|restart}"
      ;;
esac
exit $?
