
/* $Id: ssltun.h,v 1.9 2003/09/21 16:17:08 thivillon Exp $ */

#define DEFAULT_PORT 443
#define MAXCHILD 10
#define SIZE 2048
#define PROT_SIZE 32

#define SYSLOG_FAC	LOG_LOCAL6

#define CERTFILE CONFIG_PATH"/ssltunnel/ssl.cert"
#define KEYFILE  CONFIG_PATH"/ssltunnel/ssl.key"
#define CAFILE   CONFIG_PATH"/ssltunnel/ca-cert.crt"
#define USERFILE CONFIG_PATH"/ssltunnel/users"
#define DEFAULT_CONFIG_FILENAME CONFIG_PATH"/ssltunnel/tunnel.conf"
#define WTMPFILE "/var/log/ssltunnel.wtmp"
#define DEFAULT_PIDFILE  "/var/run/ssltunnel.pid"
#define DEFAULT_LOCKDIR  "/var/lock/ssltunnel"

#define DEFAULT_NETWORK_TIMEOUT	20

#define SERVER_BANNER "SSL-TUNNEL/%s PROT/1.0\n"

#define readsocket(s,b,n)       recv((s),(b),(n),0)
#define writesocket(s,b,n)      send((s),(b),(n),0)

#define MAXARGS 255

typedef struct {

  char *subject;
  char *exec;
  char *args[MAXARGS];
  int  pty;
  uid_t uid;
  gid_t gid;
  char *fingerprint;
  char *issuer;

} ClientData;

typedef int bool;

typedef struct key_value
{
   char *key ;
   char *value ;
}
key_value_t ;

#define FALSE 0
#define TRUE  1
#define false 0
#define true  1

typedef struct {

  char *keyfile;                /* Key File */
  char *certfile;               /* Certificate */
  char *cacertfile;             /* List of trusted certificates */
  int  maxclients;              /* Max Clients */
  char *userfile;		/* UserFiles */
  char *listenaddr;             /* Limit address */
  int  port;                    /* Port */
  char *wtmp;                   /* Wmtp File */
  int  network_timeout;         /* Network Timeout */
  char *pidfile;		/* Pid File */
  char *lockdir;		/* Locking directory */

} tunnel ;


#ifdef UT_LINESIZE

typedef struct utmp ssltunnel_utmp_t;

#else

/* For Solariche */

#define UT_NAMESIZE     16      /* see MAXLOGNAME in <sys/param.h> */
#define UT_LINESIZE     8
#define UT_HOSTSIZE     16

typedef struct ssltunnel_utmp {
        char    ut_line[UT_LINESIZE];
        char    ut_name[UT_NAMESIZE];
        char    ut_host[UT_HOSTSIZE];
        time_t  ut_time;
} ssltunnel_utmp_t;

#endif

